VERSION 4.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   8400
   ClientLeft      =   1140
   ClientTop       =   1575
   ClientWidth     =   6690
   Height          =   8835
   Left            =   1080
   LinkTopic       =   "Form1"
   ScaleHeight     =   8400
   ScaleWidth      =   6690
   Top             =   1200
   Width           =   6810
End
Attribute VB_Name = "Form1"
Attribute VB_Creatable = False
Attribute VB_Exposed = False
Option Explicit

Private Sub Form_Load()
    'test binary versions
    Dim r As Long   'generic return value
    Dim i As Long
    Dim sFile As String
    sFile = "t.log"
    
    'get the original data
    Dim raw_len As Long
    raw_len = FileLen(sFile)
    ReDim raw_data(raw_len) As Byte
    Open sFile For Binary As #1
    For i = 0 To raw_len - 1
        Get #1, , raw_data(i)
    Next
    Close #1
    
    'establish a buffer for the compressed data
    Dim cmp_len As Long
    cmp_len = raw_len + 12 + (raw_len / 1000)
    ReDim cmp_data(cmp_len) As Byte
    
    'establish a buffer for the uncompressed data
    ReDim uncmp_data(raw_len + 2) As Byte
    Dim uncmp_len As Long
    uncmp_len = raw_len + 2
    
    'try compressing
    r = compress(cmp_data(0), cmp_len, raw_data(0), raw_len)
    If r <> 0 Then
        MsgBox "The compress routine failed, returning " & r
    End If
    
    r = uncompress(uncmp_data(0), uncmp_len, cmp_data(0), cmp_len)
    If r <> 0 Then
        MsgBox "The uncompress routine failed, returning " & r
    End If
      
    If uncmp_len <> raw_len Then
        MsgBox "The uncompress routine return " & uncmp_len & " bytes as the file length. The original file length was " & raw_len
    Else
        For i = 0 To raw_len - 1
            If uncmp_data(i) <> raw_data(i) Then
                MsgBox "The original data and the uncompressed data do not match."
                Exit Sub
            End If
        Next
    End If
    
    'now test the file versions
    
    Dim gFile As Long
    gFile = gzopen(sFile & ".1", "wb")
    If gFile <= 0 Then
        MsgBox "The gzopen() for write call failed."
        Exit Sub
    End If
    r = gzwrite(gFile, raw_data(0), raw_len)
    If r <> raw_len Then
        MsgBox "The gzwrite() call returned an error"
        Exit Sub
    End If
    r = gzclose(gFile)
    If r <> 0 Then
        MsgBox "The gzclose() called failed."
    End If
    
    gFile = gzopen(sFile & ".1", "rb")
    If gFile <= 0 Then
        MsgBox "The gzopen() for read call failed."
        Exit Sub
    End If
    r = gzread(gFile, uncmp_data(0), raw_len + 2)
    If r < 0 Then
        MsgBox "The gzread() call failed"
        Exit Sub
    End If
    If r <> raw_len Then
        MsgBox "The gzread() call returned an incorrect byte count"
        Exit Sub
    End If
    r = gzclose(gFile)
        
    'save a copy of the uncompressed data,
    'in case you want to play with it
    Open sFile & ".2" For Binary As #1
    For i = 0 To raw_len - 1
        Put #1, , uncmp_data(i)
    Next
    Close #1
End Sub


